/*****************************************************************************
 *  Buttons
 *****************************************************************************

 * Buttons processing
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * thk                 1/24/09		adopted from HP16 modified for used with LCD mux  
 *thk 				1/24/09			added button five for backlight on/off
 *****************************************************************************/
#include "system.h"
#include "delay.h"

unsigned char BL_ON =0;
extern unsigned char AdcFlag;
extern unsigned char LightShowFlag;
extern unsigned char ClockFlag;

/*****************************************************************************
 * Structure: BUTTONS _button_press
 *
 * Overview: the structure provides a n access to button bit indicators.
 *
 *****************************************************************************/
unsigned char _b1_cnt;
unsigned char _b2_cnt;
unsigned char _b3_cnt;
unsigned char _b4_cnt;
unsigned char _b5_cnt;
BUTTON _button_press;

/*****************************************************************************
 * Function: BtnInit
 *
 * Preconditon: None.
 *
 * Overview: Setup debounce.
 *
 * Input: None.
 *
 * Output: None.
 *
 *****************************************************************************/
void BtnInit(void)
{
	_b1_cnt = 2;
	_b2_cnt = 2;
	_b3_cnt = 2;
	_b4_cnt = 2;
	_b5_cnt = 2;
	_button_press.b1 = 0;
	_button_press.b2 = 0;
	_button_press.b3 = 0;
	_button_press.b4 = 0;
	///****added for backlight swtich and control
//		TRISBbits.TRISB12 =1;   //button five input
//		BLACKLIGHT =0; //start out low for control
//		TRISBbits.TRISB13 =0;  //transistor control
		
	
}

/*****************************************************************************
 * Function: BtnProcessEvents
 *
 * Preconditon: None.
 *
 * Overview: Must be called periodically to proccess buttons.
 *
 * Input: None.
 *
 * Output: None.
 Button are mux with LCD data lines and so must be switched to input
 and output on return
 *
 *****************************************************************************/
 //simplified library for Nuts and Volts
 
 int  process_buttons(void) {
	 int button =0;
 	delay_5msec();     //debounce time
	BtnProcessEvents();		//check button conditions
		if (BtnIsPressed(1) ) {
                // do something 
             	button=1;
                // wait for button released
                while (BtnIsPressed(1))	BtnProcessEvents();
}	
	if (BtnIsPressed(2) ) {
                // do something 
             	button =2;       
                // wait for button released
                while (BtnIsPressed(2))	BtnProcessEvents();
}	
	if (BtnIsPressed(3) ) {
                // do something 
              button =3;
                 // wait for button released
                while (BtnIsPressed(3))	BtnProcessEvents();
}	
	if (BtnIsPressed(4) ) {
                // do something 
               button =4;
	                // wait for button released
                while (BtnIsPressed(4))	BtnProcessEvents();
}	
	return button;
}
void BtnProcessEvents(void)
{
	//switch to inputs
	LATAbits.LATA0 =1;
		TRISAbits.TRISA0=1;
		TRISAbits.TRISA1=1;
		TRISAbits.TRISA2=1;
		TRISAbits.TRISA3=1;
	
		if (!BUTTON1) {
		_b1_cnt++;
		if (_b1_cnt > (10 + BUTTON_MAX_DEBOUCE)){
			_b1_cnt = (10 + BUTTON_MAX_DEBOUCE);
			_button_press.b1 = 1;
		}		
	}
	else {
		_b1_cnt--;
		if (_b1_cnt < (10 - BUTTON_MAX_DEBOUCE)){
			_b1_cnt = (10 - BUTTON_MAX_DEBOUCE);
			_button_press.b1 = 0;
		}
	}
 

	if (!BUTTON2) {
		_b2_cnt++;
		if (_b2_cnt > (10 + BUTTON_MAX_DEBOUCE)){
			_b2_cnt = (10 + BUTTON_MAX_DEBOUCE);
			_button_press.b2 = 1;
		}
	}
	else {
		_b2_cnt--;
		if (_b2_cnt < (10 - BUTTON_MAX_DEBOUCE)){
			_b2_cnt = (10 - BUTTON_MAX_DEBOUCE);
			_button_press.b2 = 0;
		}
	}


	if (!BUTTON3) {
		_b3_cnt++;
		if (_b3_cnt > (10 + BUTTON_MAX_DEBOUCE)){
			_b3_cnt = (10 + BUTTON_MAX_DEBOUCE);
			_button_press.b3 = 1;
			
		}
	}
	else {
		_b3_cnt--;
		if (_b3_cnt < (10 - BUTTON_MAX_DEBOUCE)){
			_b3_cnt = (10 - BUTTON_MAX_DEBOUCE);
			_button_press.b3 = 0;
		}
	}


	if (!BUTTON4) {
		_b4_cnt++;
		if (_b4_cnt > (10 + BUTTON_MAX_DEBOUCE)){
			_b4_cnt = (10 + BUTTON_MAX_DEBOUCE);
			_button_press.b4 = 1;
		}
	}
	else {
		_b4_cnt--;
		if (_b4_cnt < (10 - BUTTON_MAX_DEBOUCE)){
			_b4_cnt = (10 - BUTTON_MAX_DEBOUCE);
			_button_press.b4 = 0;
		}
		
}

//	switch back to outputs
	LATAbits.LATA0 =0;
	TRISAbits.TRISA0=0;
	LATAbits.LATA1 =0;
	TRISAbits.TRISA1=0;
	LATAbits.LATA2 =0;
	TRISAbits.TRISA2=0;
	LATAbits.LATA3 =0;
	TRISAbits.TRISA3=0;
}
//***************quickie button check**********************************

//***********************************************************************
//back light on/off
void toggle_BL(void) {
	
 BL_ON ^=1;	
 BLACKLIGHT =BL_ON;
 
	
}	
/*****************************************************************************
 * EOF
 *****************************************************************************/

